/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, runOn, markType } from "igniteui-angular-core/ES5/type";
import { Pool$1 } from "igniteui-angular-core/ES5/Pool$1";
import { TreemapVisual } from "./TreemapVisual";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Rectangle } from "igniteui-angular-core/ES5/Rectangle";
import { TextBlock } from "igniteui-angular-core/ES5/TextBlock";
/**
 * @hidden
 */
var TreemapViewRenderer = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapViewRenderer, _super);
    function TreemapViewRenderer() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.c = null;
        _this.i = null;
        _this.c = new List$1(TreemapVisual.$, 0);
        _this.b = ((function () {
            var $ret = new Pool$1(TreemapVisual.$);
            $ret.create = runOn(_this, _this.a);
            $ret.activate = runOn(_this, _this.f);
            $ret.disactivate = runOn(_this, _this.h);
            $ret.destroy = runOn(_this, _this.g);
            return $ret;
        })());
        return _this;
    }
    TreemapViewRenderer.prototype.a = function () {
        var a = new TreemapVisual();
        this.c.add(a);
        return a;
    };
    TreemapViewRenderer.prototype.f = function (a) {
        a.n = 0;
    };
    TreemapViewRenderer.prototype.h = function (a) {
        a.n = 1;
    };
    TreemapViewRenderer.prototype.g = function (a) {
        this.c.remove(a);
    };
    TreemapViewRenderer.prototype.d = function (a) {
        if (a.c.count != 2) {
            a.c.add1(new Rectangle());
            a.c.add1(new Rectangle());
            a.c.add1(new TextBlock());
        }
    };
    TreemapViewRenderer.prototype.e = function (a, b, c) {
        a.k(b.left, b.top, b.width, b.height);
        if (c != null) {
            for (var d = 0; d < c.count; d++) {
                var e = c._inner[d];
                this.d(e);
                var f = e.c._inner[0];
                var g = e.c._inner[1];
                var h = e.c._inner[2];
                f._fill = e.h;
                f._stroke = e.k;
                f.ac = e.f;
                f.width = e.l.width;
                f.height = e.l.height;
                f.n = e.l.left;
                f.o = e.l.top;
                a.ac(e.a);
                if (e.b) {
                    h.ak = e.g;
                    h.n = e.l.left + e.l.width / 2 - e.e / 2 + e.f;
                    h.o = e.l.top + e.l.height / 2 - e.d / 2 + e.f;
                    h.am = e.j;
                }
                else {
                    g._fill = e.i;
                    g._stroke = e.k;
                    g.ac = e.f;
                    g.width = e.l.width;
                    g.height = e.d;
                    g.n = e.l.left;
                    g.o = e.l.top;
                    h.n = e.l.left + e.m.c + e.f;
                    h.o = e.l.top + e.m.e + e.f;
                    h.ak = e.g;
                    h.am = e.j;
                }
                a.v(f);
                if (!e.b) {
                    a.v(g);
                }
                a.z();
                a.ae(e.l);
                a.w(h);
                a.y();
            }
        }
    };
    TreemapViewRenderer.$t = markType(TreemapViewRenderer, 'TreemapViewRenderer');
    return TreemapViewRenderer;
}(Base));
export { TreemapViewRenderer };
//# sourceMappingURL=TreemapViewRenderer.js.map