/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, runOn, delegateCombine, delegateRemove, markType, fromEnum, String_$type, INotifyPropertyChanged_$type, PropertyChangedEventArgs, EventArgs, fromEn, EnumUtil, enumGetBox, typeGetValue, Point_$type } from "igniteui-angular-core/ES5/type";
import { TreemapViewRenderer } from "./TreemapViewRenderer";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
import { FontInfo } from "igniteui-angular-core/ES5/FontInfo";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { CanvasViewRenderer } from "igniteui-angular-core/ES5/CanvasViewRenderer";
import { CanvasGestureDOMEventProxy } from "igniteui-angular-core/ES5/CanvasGestureDOMEventProxy";
import { TreemapVisual } from "./TreemapVisual";
import { FontUtil } from "igniteui-angular-core/ES5/FontUtil";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { truncate, isNaN_, logBase } from "igniteui-angular-core/ES5/number";
import { HashSet$1 } from "igniteui-angular-core/ES5/HashSet$1";
import { Thickness } from "igniteui-angular-core/ES5/Thickness";
import { TreemapOrientation_$type } from "./TreemapOrientation";
import { Size } from "igniteui-angular-core/ES5/Size";
import { AreaInfo } from "./AreaInfo";
import { Dictionary$2 } from "igniteui-angular-core/ES5/Dictionary$2";
import { DoubleAnimator } from "igniteui-angular-core/ES5/DoubleAnimator";
import { BrushCollection } from "igniteui-angular-core/ES5/BrushCollection";
import { TreemapFillScaleMode_$type } from "./TreemapFillScaleMode";
import { TreemapLayoutType_$type } from "./TreemapLayoutType";
import { FastItemsSource } from "igniteui-angular-core/ES5/FastItemsSource";
import { DeviceUtils } from "igniteui-angular-core/ES5/DeviceUtils";
import { EasingFunctions } from "igniteui-angular-core/ES5/EasingFunctions";
import { ObservableCollection$1 } from "igniteui-angular-core/ES5/ObservableCollection$1";
import { BrushCollectionUtil } from "igniteui-angular-core/ES5/BrushCollectionUtil";
import { TreemapValueMappingMode_$type } from "./TreemapValueMappingMode";
import { TreemapNodePointerEventArgs } from "./TreemapNodePointerEventArgs";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-angular-core/ES5/string";
import { BrushUtil } from "igniteui-angular-core/ES5/BrushUtil";
/**
 * @hidden
 */
var TreemapView = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapView, _super);
    function TreemapView() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.a = null;
        _this.m = false;
        _this.ac = null;
        _this.j = null;
        _this.aa = null;
        _this.q = 0;
        _this.p = 0;
        _this.e = null;
        _this.ab = null;
        _this.t = 1;
        _this.z = null;
        _this.c = null;
        _this.r = 0;
        _this.s = 0;
        _this.a0 = null;
        _this.g = null;
        _this.f = null;
        _this.o = null;
        _this.k = null;
        _this.d = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 13;
            return $ret;
        })());
        _this.l = true;
        _this.b = new TreemapViewRenderer();
        _this.b.i = ((function () {
            var $ret = new Brush();
            $ret.fill = "white";
            return $ret;
        })());
        return _this;
    }
    TreemapView.prototype.at = function () {
    };
    TreemapView.prototype.ax = function () {
        this.aw();
    };
    TreemapView.prototype.ay = function () {
        if (!this.m) {
            this.m = true;
            if (this.aa != null) {
                this.aa.setTimeout(runOn(this, this.ad), 0);
            }
            else {
                window.setTimeout(runOn(this, this.ad), 0);
            }
        }
    };
    TreemapView.prototype.ad = function () {
        if (this.m) {
            this.m = false;
            this.a.ev();
        }
    };
    TreemapView.prototype.n = function () {
        return true;
    };
    TreemapView.prototype.au = function () {
        this.t = this.a.bt;
        this.ay();
    };
    TreemapView.prototype.aq = function (a) {
        if (a == null) {
            this.ac = null;
            this.aa = null;
            this.j = null;
            if (this.z != null) {
                window.removeEventListener("resize", this.z, false);
                this.z = null;
            }
            this.ae();
            return;
        }
        this.aa = a;
        this.ab = a;
        var b = this.ab.rootWrapper.width();
        var c = this.ab.rootWrapper.height();
        this.an();
        this.t = (isNaN_(this.a.b9) ? this.a.bt : this.a.b9);
        var d = this.t;
        var e = Math.round(a.rootWrapper.width());
        var f = Math.round(a.rootWrapper.height());
        var g = e * d;
        var h = f * d;
        this.aa.rootWrapper.setStyleProperty("position", "relative");
        var i = a.createElement("canvas");
        i.setStyleProperty("position", "absolute");
        this.aa.rootWrapper.append(i);
        this.q = b;
        this.p = c;
        i.setAttribute("width", g.toString());
        i.setAttribute("height", h.toString());
        i.setStyleProperty("width", e.toString() + "px");
        i.setStyleProperty("height", f.toString() + "px");
        this.k = i.listen("contextmenu", function (j) { return j.preventDefault(); });
        this.a.fl = new Rect(0, 0, 0, e, f);
        this.ac = i;
        var j = this.aa.get2DCanvasContext(this.ac);
        this.j = new RenderingContext(new CanvasViewRenderer(), j);
        this.am();
        this.az();
        this.j.ac(this.e);
        this.aw();
        this.c = new CanvasGestureDOMEventProxy(this.ac, this.aa, true);
        this.c.ak = function (k) { return true; };
        this.c.bf = this.a.fl;
        var k = this.c;
        k.onMouseOver = delegateCombine(k.onMouseOver, runOn(this, this.aj));
        var l = this.c;
        l.onMouseUp = delegateCombine(l.onMouseUp, runOn(this, this.ak));
        var m = this.c;
        m.onMouseDown = delegateCombine(m.onMouseDown, runOn(this, this.ag));
        var n = this.c;
        n.onMouseEnter = delegateCombine(n.onMouseEnter, runOn(this, this.ah));
        var o = this.c;
        o.onMouseLeave = delegateCombine(o.onMouseLeave, runOn(this, this.ai));
    };
    TreemapView.prototype.ai = function (a) {
        this.a.ek(a);
    };
    TreemapView.prototype.ah = function (a) {
        this.a.ej(a);
    };
    TreemapView.prototype.an = function () {
        var _this = this;
        if (this.z == null) {
            this.z = function (a) {
                var b = _this.a.b9;
                var c = _this.a.bt;
                if (!isNaN_(b) && b != 0) {
                    return;
                }
                if (window.devicePixelRatio != undefined && window.devicePixelRatio != c) {
                    _this.a.bt = window.devicePixelRatio;
                }
            };
            var e_ = this.z;
            window.addEventListener("resize", e_, false);
        }
        this.z(null);
    };
    TreemapView.prototype.ae = function () {
        if (this.k != null) {
            this.k();
            this.k = null;
        }
        if (this.c != null) {
            var a = this.c;
            a.onMouseOver = delegateRemove(a.onMouseOver, runOn(this, this.aj));
            var b = this.c;
            b.onMouseUp = delegateRemove(b.onMouseUp, runOn(this, this.ak));
            var c = this.c;
            c.onMouseDown = delegateRemove(c.onMouseDown, runOn(this, this.ag));
            var d = this.c;
            d.onMouseEnter = delegateRemove(d.onMouseEnter, runOn(this, this.ah));
            var e = this.c;
            e.onMouseLeave = delegateRemove(e.onMouseLeave, runOn(this, this.ai));
            this.c.ak = null;
            this.c.aq();
        }
    };
    TreemapView.prototype.ag = function (a) {
        if (this.c.ai) {
            this.a.eo(a);
        }
        else {
            this.a.ei(a);
        }
    };
    TreemapView.prototype.ak = function (a) {
        if (this.c.ai) {
            this.a.ep(a);
        }
        else {
            this.a.em(a);
        }
    };
    TreemapView.prototype.aj = function (a, b, c) {
        this.a.el(a);
    };
    TreemapView.prototype.am = function () {
    };
    TreemapView.prototype.i = function () {
        return this.b.b;
    };
    TreemapView.prototype.az = function () {
        this.e = FontUtil.getFont(this.aa);
        if (this.f != null) {
            this.r = this.u(this.f);
        }
        else {
            this.r = this.u(this.e);
        }
        if (this.g != null) {
            this.s = this.u(this.g);
        }
        else {
            this.s = this.u(this.e);
        }
        this.a0 = new Brush();
        this.a0._fill = this.aa.rootWrapper.getStyleProperty("color");
        if (this.j != null) {
            this.j.ac(this.e);
        }
    };
    TreemapView.prototype.ao = function () {
        var a = this.ab.rootWrapper.width();
        var b = this.ab.rootWrapper.height();
        this.a.fl = new Rect(0, 0, 0, a, b);
        this.an();
    };
    TreemapView.prototype.al = function () {
        if (this.m) {
            this.ad();
        }
    };
    TreemapView.prototype.aw = function () {
        if (this.j == null) {
            return;
        }
        var a = this.a.fl.width;
        var b = this.a.fl.height;
        var c = Math.round(a * this.t);
        var d = Math.round(b * this.t);
        if (this.q != c || this.p != d) {
            this.ac.setAttribute("width", c.toString());
            this.ac.setAttribute("height", d.toString());
            this.ac.setStyleProperty("width", a.toString() + "px");
            this.ac.setStyleProperty("height", b.toString() + "px");
            this.q = truncate(Math.round(c));
            this.p = truncate(Math.round(d));
        }
        if (this.j.d && this.t != 1) {
            this.j.z();
            this.j.aa(this.t, this.t);
        }
        this.b.e(this.j, this.a.fl, this.o);
        if (this.j.d && this.t != 1) {
            this.j.y();
        }
    };
    TreemapView.prototype.as = function (a) {
        if (this.g != null) {
            this.s = this.u(this.g);
        }
        else {
            this.s = this.u(this.e);
        }
        this.g = a;
    };
    TreemapView.prototype.av = function (a) {
        if (this.f != null) {
            this.r = this.u(this.f);
        }
        else {
            this.r = this.u(this.e);
        }
        this.f = a;
    };
    TreemapView.prototype.af = function (a) {
        this.o = a;
        this.aw();
    };
    TreemapView.prototype.y = function (a) {
        if (a != null) {
            if (this.f != null) {
                this.j.ac(this.f);
            }
            else {
                this.j.ac(this.d);
            }
            return this.j.f(a);
        }
        return 0;
    };
    TreemapView.prototype.w = function (a) {
        if (a != null) {
            if (this.g != null) {
                this.j.ac(this.g);
            }
            else {
                this.j.ac(this.d);
            }
            return this.j.f(a);
        }
        return 0;
    };
    TreemapView.prototype.u = function (a) {
        return FontUtil.getCurrentFontHeight(this.aa, a);
    };
    TreemapView.prototype.x = function (a) {
        return this.r;
    };
    TreemapView.prototype.v = function (a) {
        return this.s;
    };
    TreemapView.prototype.a1 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "rgb(220,220,220)";
            return $ret;
        })());
    };
    TreemapView.prototype.a2 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "black";
            return $ret;
        })());
    };
    TreemapView.prototype.a4 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "black";
            return $ret;
        })());
    };
    TreemapView.prototype.a3 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "rgb(240,240,240)";
            return $ret;
        })());
    };
    TreemapView.prototype.a5 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "rgb(240, 240, 240)";
            return $ret;
        })());
    };
    TreemapView.prototype.h = function () {
        return this.d;
    };
    TreemapView.prototype.ap = function () {
        this.l = true;
        this.an();
        if (this.c != null) {
            this.c.ap(this.aa.rootWrapper, "");
        }
    };
    TreemapView.prototype.ar = function () {
        this.l = false;
        if (this.c != null) {
            this.c.bb(this.aa.rootWrapper, "");
        }
    };
    TreemapView.$t = markType(TreemapView, 'TreemapView');
    return TreemapView;
}(Base));
export { TreemapView };
/**
 * @hidden
 */
var TreemapLayoutCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapLayoutCalculator, _super);
    function TreemapLayoutCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TreemapLayoutCalculator.c = function (a, b, c) {
        var d = a.e();
        var e = c.f;
        var f = e * e / (b.width * b.height);
        if (d / (b.width * b.height) < f) {
            return true;
        }
        return false;
    };
    TreemapLayoutCalculator.a = function (a, b, c, d, e) {
        for (var f = 0; f < c.count; f++) {
            var g = c._inner[f];
            if (!a.contains(g)) {
                return false;
            }
        }
        return true;
    };
    TreemapLayoutCalculator.b = function (a, b) {
        if (a.width < b.f || a.height < b.f) {
            return true;
        }
        return false;
    };
    TreemapLayoutCalculator.f = function (a, b, c, d, e, f) {
        var e_1, _a;
        if (!TreemapLayoutCalculator.a(a, b, c, e, f)) {
            while (d > 0) {
                var g = 0;
                try {
                    for (var _b = tslib_1.__values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var h = _c.value;
                        if (a.contains(h)) {
                            continue;
                        }
                        if (d > 0) {
                            var i = (d > 1) ? 1 : d;
                            var j = b.j(h);
                            if (j.isEmpty) {
                                continue;
                            }
                            b.i(h, new Rect(0, j.x + g, j.y, j.width + i, j.height));
                            d -= i;
                            g += i;
                        }
                        else {
                            var k = b.j(h);
                            if (k.isEmpty) {
                                continue;
                            }
                            b.i(h, new Rect(0, k.x + g, k.y, k.width, k.height));
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
        }
    };
    TreemapLayoutCalculator.e = function (a, b, c, d, e, f) {
        var e_2, _a;
        if (!TreemapLayoutCalculator.a(a, b, c, e, f)) {
            while (d > 0) {
                var g = 0;
                try {
                    for (var _b = tslib_1.__values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var h = _c.value;
                        if (a.contains(h)) {
                            continue;
                        }
                        if (d > 0) {
                            var i = (d > 1) ? 1 : d;
                            var j = b.j(h);
                            if (j.isEmpty) {
                                continue;
                            }
                            b.i(h, new Rect(0, j.x, j.y + g, j.width, j.height + i));
                            d -= i;
                            g += i;
                        }
                        else {
                            var k = b.j(h);
                            if (k.isEmpty) {
                                continue;
                            }
                            b.i(h, new Rect(0, k.x, k.y + g, k.width, k.height));
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
    };
    TreemapLayoutCalculator.$t = markType(TreemapLayoutCalculator, 'TreemapLayoutCalculator');
    return TreemapLayoutCalculator;
}(Base));
export { TreemapLayoutCalculator };
/**
 * @hidden
 */
var StrippedCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(StrippedCalculator, _super);
    function StrippedCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StrippedCalculator.prototype.d = function (a, b) {
        a.f();
        this.l(a, b.b.a, b.h, b, 0);
    };
    StrippedCalculator.prototype.n = function (a, b, c) {
        return new Thickness(0, 4);
    };
    StrippedCalculator.prototype.l = function (a, b, c, d, e) {
        var e_3, _a;
        if (d.g >= 0 && e > d.g) {
            return;
        }
        if (b == d.c) {
            d.d = true;
            a.i(b, c);
            var f = new Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
            c = f;
        }
        if (!d.d) {
            try {
                for (var _b = tslib_1.__values(fromEnum(b.b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    this.l(a, g, c, d, e + 1);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return;
        }
        var h = this.n(b, c, d);
        var i = h.c + h.d;
        var j = h.e + h.b;
        var k = new Rect(0, c.left, c.top, c.width, c.height);
        var l = d.a;
        if (i >= k.width || j >= k.height) {
            return;
        }
        k.x = k.x + h.c;
        k.width = k.width - i;
        k.y = k.y + h.e;
        k.height = k.height - j;
        var m = new HashSet$1(TreemapTreeNode.$, 0);
        StrippedCalculator.m(m, d, b.b, k);
        var n = 0;
        for (var o = 0; o < b.b.count; o++) {
            var p = b.b._inner[o];
            if (!m.contains(p)) {
                n += p.e();
            }
        }
        var q = n;
        var r = (k.width * k.height) / q;
        var s = l == 0 ? k.width : k.height;
        var t = new List$1(TreemapTreeNode.$, 0);
        var u = new List$1(TreemapTreeNode.$, 0);
        for (var v = 0; v < b.b.count; v++) {
            var w = b.b._inner[v];
            if (m.contains(w) || isNaN_(w.e())) {
                continue;
            }
            var x = StrippedCalculator.g(u, s, r);
            u.add(w);
            var y = StrippedCalculator.g(u, s, r);
            if (x < y) {
                if (t.count > 0) {
                    var z = StrippedCalculator.j(m, a, d, t, r, k, l, false);
                    k = z.p5;
                }
                u.removeAt(u.count - 1);
                t.o(u);
                u.clear();
                u.add(w);
            }
        }
        var aa = StrippedCalculator.g(t, s, r);
        var ab = StrippedCalculator.g(u, s, r);
        var ac = new List$1(TreemapTreeNode.$, 0);
        ac.o(t);
        ac.o(u);
        var ad = StrippedCalculator.g(ac, s, r);
        if (ad < (aa + ab) / 2 || k.height < d.f * 2) {
            var ae = StrippedCalculator.j(m, a, d, ac, r, k, l, true);
            k = ae.p5;
        }
        else {
            var af = StrippedCalculator.j(m, a, d, t, r, k, l, false);
            k = af.p5;
            var ag = StrippedCalculator.j(m, a, d, u, r, k, l, true);
            k = ag.p5;
        }
        for (var ah = 0; ah < b.b.count; ah++) {
            var ai = b.b._inner[ah];
            if (m.contains(ai)) {
                continue;
            }
            var aj = a.j(ai);
            if (aj.isEmpty) {
                continue;
            }
            var ak = new Rect(0, aj.left, aj.top + d.e, aj.width, Math.max(aj.height - d.e, 0));
            this.l(a, ai, ak, d, e + 1);
        }
        if (b == d.c) {
            d.d = false;
        }
    };
    StrippedCalculator.j = function (a, b, c, d, e, f, g, h) {
        if (d.count == 0) {
            return {
                p5: f
            };
        }
        if (g == 0) {
            var i = StrippedCalculator.i(a, b, c, d, e, f, h);
            f = i.p5;
        }
        else {
            var j = StrippedCalculator.k(a, b, c, d, e, f, h);
            f = j.p5;
        }
        return {
            p5: f
        };
    };
    StrippedCalculator.i = function (a, b, c, d, e, f, g) {
        var h = StrippedCalculator.h(d);
        if (h <= 0) {
            return {
                p5: f
            };
        }
        var i = f.width;
        var j = (h * e) / i;
        var k = f.x;
        var l = 0;
        for (var m = 0; m < d.count; ++m) {
            var n = d._inner[m];
            var o = Math.floor((n.e() / h) * i);
            var p = new Rect(0, k, f.y, o, j);
            if (TreemapLayoutCalculator.b(p, c)) {
                a.add_1(n);
            }
            else {
                l = p.right;
                b.i(n, p);
            }
            if (a.contains(n)) {
                h -= n.e();
            }
            else {
                k += o;
            }
        }
        TreemapLayoutCalculator.f(a, b, d, f.right - k, f, c);
        f.y = f.y + j;
        if (f.height < j) {
            f.height = 0;
        }
        else {
            f.height = f.height - j;
        }
        d.clear();
        return {
            p5: f
        };
    };
    StrippedCalculator.k = function (a, b, c, d, e, f, g) {
        var h = StrippedCalculator.h(d);
        if (h <= 0) {
            return {
                p5: f
            };
        }
        var i = f.height;
        var j = (h * e) / i;
        var k = f.y;
        var l = 0;
        for (var m = 0; m < d.count; ++m) {
            var n = d._inner[m];
            var o = Math.floor((n.e() / h) * i);
            var p = new Rect(0, f.x, k, j, o);
            if (TreemapLayoutCalculator.b(p, c)) {
                a.add_1(n);
            }
            else {
                l = p.bottom;
                b.i(n, p);
            }
            if (a.contains(n)) {
                h -= n.e();
            }
            else {
                k += o;
            }
        }
        TreemapLayoutCalculator.e(a, b, d, f.bottom - k, f, c);
        f.x = f.x + j;
        if (f.width < j) {
            f.width = 0;
        }
        else {
            f.width = f.width - j;
        }
        d.clear();
        return {
            p5: f
        };
    };
    StrippedCalculator.g = function (a, b, c) {
        if (a.count == 0) {
            return 1.7976931348623157E+308;
        }
        var d = StrippedCalculator.h(a);
        var e = (d * c) / b;
        var f = 0;
        for (var g = 0; g < a.count; g++) {
            var h = a._inner[g];
            var i = (h.e() / d) * b;
            f += Math.max(i / e, e / i);
        }
        f /= a.count;
        return f;
    };
    StrippedCalculator.h = function (a) {
        var b = 0;
        for (var c = 0; c < a.count; c++) {
            var d = a._inner[c];
            b += d.e();
        }
        return b;
    };
    StrippedCalculator.m = function (a, b, c, d) {
        var e = 0;
        for (var f = 0; f < c.count; f++) {
            var g = c._inner[f];
        }
        var h = e;
        var i = b.f * b.f / (d.width * d.height);
        for (var j = 0; j < c.count; j++) {
            var k = c._inner[j];
            if (k.e() / h < i) {
                a.add_1(k);
            }
        }
    };
    StrippedCalculator.$t = markType(StrippedCalculator, 'StrippedCalculator', TreemapLayoutCalculator.$);
    return StrippedCalculator;
}(TreemapLayoutCalculator));
export { StrippedCalculator };
/**
 * @hidden
 */
var SliceAndDiceCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(SliceAndDiceCalculator, _super);
    function SliceAndDiceCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SliceAndDiceCalculator.prototype.d = function (a, b) {
        a.f();
        this.j(a, b.b.a, b.h, b, 0);
    };
    SliceAndDiceCalculator.prototype.l = function (a, b, c) {
        return new Thickness(0, 4);
    };
    SliceAndDiceCalculator.prototype.j = function (a, b, c, d, e) {
        var e_4, _a;
        if (d.g >= 0 && e > d.g) {
            return;
        }
        if (b == d.c) {
            d.d = true;
            a.i(b, c);
            var f = new Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
            c = f;
        }
        if (!d.d) {
            try {
                for (var _b = tslib_1.__values(fromEnum(b.b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    this.j(a, g, c, d, e + 1);
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_4) throw e_4.error; }
            }
            return;
        }
        var h = this.l(b, c, d);
        var i = SliceAndDiceCalculator.g(b, d, e);
        var j = h.c + h.d;
        var k = h.e + h.b;
        var l = new Rect(0, c.left, c.top, c.width, c.height);
        if (j >= l.width || k >= l.height) {
            return;
        }
        l.x = l.x + h.c;
        l.width = l.width - j;
        l.y = l.y + h.e;
        l.height = l.height - k;
        var m = new Size(1, l.width, l.height);
        var n = l.left;
        var o = l.top;
        var p = new HashSet$1(TreemapTreeNode.$, 0);
        var q = SliceAndDiceCalculator.h(b.b, b, d, m, p);
        if (q) {
            SliceAndDiceCalculator.k(b.b, b, d, m, p);
        }
        var r = 0;
        for (var s = 0; s < b.b.count; s++) {
            var t = b.b._inner[s];
            if (!p.contains(t)) {
                r += t.e();
            }
        }
        var u = (i == 0) ? m.height : m.width;
        var v = new Rect(4);
        for (var w = 0; w < b.b.count; w++) {
            var x = b.b._inner[w];
            if (p.contains(x) || isNaN_(x.e())) {
                continue;
            }
            if (r <= 0 || u <= 0) {
                break;
            }
            var y = x.e() / r;
            v.x = n;
            v.y = o;
            if (i == 0) {
                v.width = m.width;
                v.height = Math.round(u * y);
            }
            else {
                v.width = Math.round(u * y);
                v.height = m.height;
            }
            a.i(x, new Rect(0, v.left, v.top, v.width, v.height));
            if (i == 0) {
                o += v.height;
                u -= v.height;
            }
            else {
                n += v.width;
                u -= v.width;
            }
            r -= x.e();
            var z = a.j(x);
            if (z.isEmpty) {
                continue;
            }
            var aa = new Rect(0, z.left, z.top + d.e, z.width, Math.max(z.height - d.e, 0));
            this.j(a, x, aa, d, e + 1);
        }
        if (b == d.c) {
            d.d = false;
        }
    };
    SliceAndDiceCalculator.g = function (a, b, c) {
        var d = 0;
        if (b.a == 0) {
            d = (c % 2 == 0) ? 0 : 1;
        }
        else {
            d = (c % 2 == 0) ? 1 : 0;
        }
        return d;
    };
    SliceAndDiceCalculator.h = function (a, b, c, d, e) {
        var f = true;
        var g = b.e();
        var h = Math.min(d.width, d.height);
        for (var i = 0; i < a.count; i++) {
            var j = a._inner[i];
            if (Math.round(j.e() / g * h) < c.f) {
                if (!e.contains(j)) {
                    e.add_1(j);
                }
            }
            else {
                f = false;
            }
        }
        return f;
    };
    SliceAndDiceCalculator.k = function (a, b, c, d, e) {
        var f = new List$1(TreemapTreeNode.$, 0);
        f.o(a);
        f.aa(function (g, h) {
            if (g.e() > h.e()) {
                return 1;
            }
            else if (g.e() < h.e()) {
                return -1;
            }
            return 0;
        });
        var g = 0;
        var h = Math.min(d.width, d.height);
        for (var i = 0; i < f.count; i++) {
            var j = f._inner[i];
            if (isNaN_(j.e())) {
                continue;
            }
            g += j.e();
            if (j.e() / g * h < c.f) {
                break;
            }
            else {
                if (e.contains(j)) {
                    e.remove(j);
                }
            }
        }
    };
    SliceAndDiceCalculator.$t = markType(SliceAndDiceCalculator, 'SliceAndDiceCalculator', TreemapLayoutCalculator.$);
    SliceAndDiceCalculator.i = null;
    return SliceAndDiceCalculator;
}(TreemapLayoutCalculator));
export { SliceAndDiceCalculator };
/**
 * @hidden
 */
var TreemapLayoutSettings = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapLayoutSettings, _super);
    function TreemapLayoutSettings() {
        var _this = _super.call(this) || this;
        _this.a = 0;
        _this.h = null;
        _this.b = null;
        _this.e = 0;
        _this.f = 0;
        _this.g = 0;
        _this.c = null;
        _this.d = false;
        _this.g = -1;
        _this.d = false;
        return _this;
    }
    TreemapLayoutSettings.$t = markType(TreemapLayoutSettings, 'TreemapLayoutSettings');
    return TreemapLayoutSettings;
}(Base));
export { TreemapLayoutSettings };
/**
 * @hidden
 */
var SquarifiedCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(SquarifiedCalculator, _super);
    function SquarifiedCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SquarifiedCalculator.prototype.k = function (a, b, c, d, e) {
        var e_5, _a, e_6, _b, e_7, _c;
        if (d.g >= 0 && e > d.g) {
            return;
        }
        if (b == d.c) {
            d.d = true;
            a.i(b, c);
            var f = new Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
            c = f;
        }
        if (!d.d) {
            try {
                for (var _d = tslib_1.__values(fromEnum(b.b)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var g = _e.value;
                    this.k(a, g, c, d, e + 1);
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
                }
                finally { if (e_5) throw e_5.error; }
            }
            return;
        }
        var h = this.l(b, c, d);
        var i = new Rect(0, c.left, c.top, c.width, c.height);
        var j = h.c + h.d;
        var k = h.e + h.b;
        if (j >= i.width || k >= i.height) {
            return;
        }
        i.x = i.x + h.c;
        i.width = i.width - j;
        i.y = i.y + h.e;
        i.height = i.height - k;
        var l = i.left;
        var m = i.top;
        var n = new List$1(TreemapTreeNode.$, 0);
        var o = b.e();
        var p = (i.width * i.height) / o;
        var q = new List$1(TreemapTreeNode.$, 1, b.b);
        q.aa(function (r, s) {
            if (s.e() < r.e()) {
                return -1;
            }
            if (s.e() > r.e()) {
                return 1;
            }
            return 0;
        });
        var r = new AreaInfo();
        r.b = i;
        r.a = o;
        var s = new HashSet$1(TreemapTreeNode.$, 0);
        try {
            for (var _f = tslib_1.__values(fromEnum(q)), _g = _f.next(); !_g.done; _g = _f.next()) {
                var t = _g.value;
                if (TreemapLayoutCalculator.c(t, i, d) || isNaN_(t.e())) {
                    s.add_1(t);
                    continue;
                }
                var u = Math.min(i.width, i.height);
                var v = SquarifiedCalculator.g(n, u, p);
                n.add(t);
                var w = SquarifiedCalculator.g(n, u, p);
                if (v <= w) {
                    n.removeAt(n.count - 1);
                    SquarifiedCalculator.i(s, a, n, r, d);
                    i = r.b;
                    n.add(t);
                }
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
            }
            finally { if (e_6) throw e_6.error; }
        }
        SquarifiedCalculator.i(s, a, n, r, d);
        i = r.b;
        try {
            for (var _h = tslib_1.__values(fromEnum(b.b)), _j = _h.next(); !_j.done; _j = _h.next()) {
                var x = _j.value;
                if (s.contains(x)) {
                    continue;
                }
                var y = a.j(x);
                if (y.isEmpty) {
                    continue;
                }
                var z = new Rect(0, y.left, y.top + d.e, y.width, Math.max(y.height - d.e, 0));
                this.k(a, x, z, d, e + 1);
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_j && !_j.done && (_c = _h.return)) _c.call(_h);
            }
            finally { if (e_7) throw e_7.error; }
        }
        if (b == d.c) {
            d.d = false;
        }
    };
    SquarifiedCalculator.prototype.l = function (a, b, c) {
        return new Thickness(0, 4);
    };
    SquarifiedCalculator.g = function (a, b, c) {
        var e_8, _a;
        if (a.count == 0) {
            return 1.7976931348623157E+308;
        }
        var d = 0;
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        try {
            for (var _b = tslib_1.__values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var g = _c.value;
                var h = g.e() * c;
                if (e > h) {
                    e = h;
                }
                if (f < h) {
                    f = h;
                }
                d += h;
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_8) throw e_8.error; }
        }
        var i = (b * b * f) / (d * d);
        var j = (d * d) / (b * b * e);
        return Math.max(i, j);
    };
    SquarifiedCalculator.i = function (a, b, c, d, e) {
        if (c.count < 1) {
            return;
        }
        var f = 0;
        for (var g = 0; g < c.count; ++g) {
            f += c._inner[g].e();
        }
        if (f <= 0) {
            return;
        }
        if (d.b.width > d.b.height) {
            SquarifiedCalculator.h(a, b, c, f, d, e);
        }
        else {
            SquarifiedCalculator.j(a, b, c, f, d, e);
        }
    };
    SquarifiedCalculator.j = function (a, b, c, d, e, f) {
        var g = e.b;
        var h = e.a;
        var i = Math.round((d / h) * g.height);
        var j = g.x;
        for (var k = 0; k < c.count; ++k) {
            var l = c._inner[k];
            if (g.right < j) {
                a.add_1(l);
                continue;
            }
            var m = Math.floor((l.e() / d) * g.width);
            var n = new Rect(0, j, g.y, m, i);
            if (TreemapLayoutCalculator.b(n, f)) {
                a.add_1(l);
                continue;
            }
            b.i(l, n);
            j += n.width;
        }
        TreemapLayoutCalculator.f(a, b, c, g.right - j, g, f);
        g.y = g.y + i;
        if (g.height < i) {
            g.height = 0;
        }
        else {
            g.height = g.height - i;
        }
        h -= d;
        e.a = h;
        e.b = g;
        c.clear();
    };
    SquarifiedCalculator.h = function (a, b, c, d, e, f) {
        var g = e.b;
        var h = e.a;
        var i = Math.round((d / h) * g.width);
        var j = g.y;
        for (var k = 0; k < c.count; ++k) {
            var l = c._inner[k];
            if (g.bottom < j) {
                a.add_1(l);
                continue;
            }
            var m = Math.floor((l.e() / d) * g.height);
            var n = new Rect(0, g.x, j, i, m);
            if (TreemapLayoutCalculator.b(n, f)) {
                a.add_1(l);
                continue;
            }
            b.i(l, n);
            j += n.height;
        }
        TreemapLayoutCalculator.e(a, b, c, g.bottom - j, g, f);
        g.x = g.x + i;
        if (g.width < i) {
            g.width = 0;
        }
        else {
            g.width = g.width - i;
        }
        h -= d;
        e.a = h;
        e.b = g;
        c.clear();
    };
    SquarifiedCalculator.prototype.d = function (a, b) {
        a.f();
        this.k(a, b.b.a, b.h, b, 0);
    };
    SquarifiedCalculator.$t = markType(SquarifiedCalculator, 'SquarifiedCalculator', TreemapLayoutCalculator.$);
    return SquarifiedCalculator;
}(TreemapLayoutCalculator));
export { SquarifiedCalculator };
/**
 * @hidden
 */
var TreemapTreeData = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapTreeData, _super);
    function TreemapTreeData() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = null;
        _this.d = null;
        _this.c = null;
        _this.b = new Dictionary$2(String_$type, TreemapTreeNode.$, 0);
        _this.d = new List$1(String_$type, 0);
        _this.c = new Dictionary$2(String_$type, List$1.$.specialize(TreemapTreeNode.$), 0);
        _this.a = new TreemapTreeNode();
        return _this;
    }
    TreemapTreeData.prototype.e = function (a) {
        var _this = this;
        var e_9, _a;
        this.b.addItem(a.i, a);
        this.d.add(a.i);
        if (a.k == null) {
            this.a.b.add(a);
        }
        else if (this.b.containsKey(a.k)) {
            this.b.item(a.k).b.add(a);
        }
        else {
            var b_1;
            if (!((function () { var c = _this.c.tryGetValue(a.k, b_1); b_1 = c.p1; return c.ret; })())) {
                b_1 = new List$1(TreemapTreeNode.$, 0);
                this.c.item(a.k, b_1);
            }
            b_1.add(a);
        }
        if (this.c.containsKey(a.i)) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.c.item(a.i))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a.b.add(c);
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_9) throw e_9.error; }
            }
            this.c.removeItem(a.i);
        }
    };
    TreemapTreeData.prototype.g = function (a) {
        if (isNaN_(a.f)) {
            if (a.b.count > 0) {
                a.d = 0;
            }
            for (var b = 0; b < a.b.count; b++) {
                var c = a.b._inner[b];
                this.g(c);
                if (isNaN_(c.f)) {
                    a.d = a.d + c.d;
                }
                else {
                    a.d = a.d + c.f;
                }
            }
        }
    };
    TreemapTreeData.prototype.f = function () {
        this.g(this.a);
    };
    TreemapTreeData.$t = markType(TreemapTreeData, 'TreemapTreeData');
    return TreemapTreeData;
}(Base));
export { TreemapTreeData };
/**
 * @hidden
 */
var TreemapTreeNode = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapTreeNode, _super);
    function TreemapTreeNode() {
        var _this = _super.call(this) || this;
        _this.i = null;
        _this.k = null;
        _this.b = null;
        _this.c = null;
        _this.f = 0;
        _this.g = null;
        _this.d = 0;
        _this.j = null;
        _this.h = null;
        _this.a = false;
        _this.b = new List$1(TreemapTreeNode.$, 0);
        _this.f = NaN;
        _this.g = null;
        _this.c = new List$1(TreemapNodeStyleMapping.$, 0);
        _this.d = 0;
        return _this;
    }
    TreemapTreeNode.prototype.e = function () {
        if (isNaN_(this.f)) {
            return this.d;
        }
        return this.f;
    };
    TreemapTreeNode.$t = markType(TreemapTreeNode, 'TreemapTreeNode');
    return TreemapTreeNode;
}(Base));
export { TreemapTreeNode };
/**
 * @hidden
 */
var Treemap = /** @class */ (function (_super) {
    tslib_1.__extends(Treemap, _super);
    function Treemap() {
        var _this = _super.call(this) || this;
        _this.g = null;
        _this.f = null;
        _this.e = null;
        _this.ae = null;
        _this.fk = null;
        _this.af = null;
        _this.co = null;
        _this.cn = "Root";
        _this.ci = " : ";
        _this.cm = null;
        _this.cl = null;
        _this.cj = null;
        _this.ck = null;
        _this.bd = null;
        _this.a = new BrushCollection();
        _this.v = new TreemapNodeStyleMappingCollection();
        _this.c = 0;
        _this.a0 = false;
        _this.cd = 10;
        _this.bj = NaN;
        _this.bi = NaN;
        _this.e1 = null;
        _this.e0 = null;
        _this.e3 = null;
        _this.e5 = null;
        _this.e2 = null;
        _this.aj = null;
        _this.ai = null;
        _this.bm = DeviceUtils.g(10);
        _this.bo = DeviceUtils.g(3);
        _this.bn = DeviceUtils.g(10);
        _this.bl = DeviceUtils.g(3);
        _this.bk = NaN;
        _this.e4 = null;
        _this.br = NaN;
        _this.y = 0;
        _this.i = 0;
        _this.bp = 3;
        _this.ce = 500;
        _this.bs = 0;
        _this.cc = null;
        _this.ag = null;
        _this.ar = null;
        _this.an = null;
        _this.aq = null;
        _this.ao = null;
        _this.ap = null;
        _this.bq = NaN;
        _this.bf = 1;
        _this.az = false;
        _this.a4 = false;
        _this.a7 = false;
        _this.a3 = false;
        _this.aa = null;
        _this.h = null;
        _this.bg = NaN;
        _this.bh = DeviceUtils.g(1);
        _this.propertyChanged = null;
        _this.n = null;
        _this.k = null;
        _this.ad = null;
        _this.ac = null;
        _this.fj = null;
        _this.nodeStyling = null;
        _this.nodePointerOver = null;
        _this.nodePointerEnter = null;
        _this.nodePointerLeave = null;
        _this.nodePointerPressed = null;
        _this.nodePointerReleased = null;
        var a = new TreemapView();
        a.a = _this;
        _this.h = new SquarifiedCalculator();
        _this.ae = a;
        _this.ae.at();
        _this.cc = function (b, c) { return _this.d9(c.action, c.position, c.count, c.propertyName); };
        _this.fk = Rect.empty;
        _this.g = new TreemapFrame();
        _this.f = new TreemapFrame();
        _this.e = new TreemapFrame();
        _this.a4 = true;
        _this.af = new DoubleAnimator(0, 1, _this.ch);
        _this.af.b = EasingFunctions.cubicEase;
        var b = _this.af;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(_this, _this.d8));
        var c = _this.v;
        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(_this, _this.d6));
        var d = _this.v;
        d.collectionResetting = delegateCombine(d.collectionResetting, runOn(_this, _this.d7));
        return _this;
    }
    Treemap.prototype.d7 = function (a, b) {
        var e_10, _a;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.styleMappings)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.propertyChanged = delegateRemove(c.propertyChanged, runOn(this, this.ex));
            }
        }
        catch (e_10_1) { e_10 = { error: e_10_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_10) throw e_10.error; }
        }
        this.a4 = true;
        this.a7 = true;
        this.ae.ay();
    };
    Treemap.prototype.d6 = function (a, b) {
        var e_11, _a, e_12, _b;
        if (b.oldItems != null) {
            try {
                for (var _c = tslib_1.__values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    var d = c;
                    if (d != null) {
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.ex));
                    }
                }
            }
            catch (e_11_1) { e_11 = { error: e_11_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_11) throw e_11.error; }
            }
        }
        if (b.newItems != null) {
            try {
                for (var _e = tslib_1.__values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    var f = e;
                    if (f != null) {
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.ex));
                    }
                }
            }
            catch (e_12_1) { e_12 = { error: e_12_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_12) throw e_12.error; }
            }
        }
        this.a4 = true;
        this.a7 = true;
        this.ae.ay();
    };
    Treemap.prototype.ex = function (a, b) {
        this.a4 = true;
        this.a7 = true;
        this.ae.ay();
    };
    Treemap.prototype.d9 = function (a, b, c, d) {
        this.aa = null;
        this.a7 = true;
        this.ae.ay();
    };
    Treemap.prototype.notifySizeChanged = function () {
        this.ae.ao();
    };
    Treemap.prototype.destroy = function () {
        this.provideContainer(null);
    };
    Treemap.prototype.en = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.es(a, b, c);
    };
    Treemap.prototype.es = function (a, b, c) {
        var _this = this;
        switch (a) {
            case "LayoutType":
                {
                    switch (EnumUtil.getEnumValue(TreemapLayoutType_$type, c)) {
                        case 0:
                            this.h = new SquarifiedCalculator();
                            break;
                        case 1:
                            this.h = new SliceAndDiceCalculator();
                            break;
                        case 2:
                            this.h = new StrippedCalculator();
                            break;
                    }
                    this.a4 = true;
                    this.ae.ay();
                }
                break;
            case "BreadcrumbSequence":
                this.a4 = true;
                this.ae.ay();
                break;
            case "RootTitle":
                this.a4 = true;
                this.ae.ay();
                break;
            case "ValueMemberPath":
                if (this.ah != null) {
                    this.ah.deregisterColumn(this.ay);
                    this.ay = this.aw(this.d3);
                }
                this.a4 = true;
                this.a3 = true;
                this.ae.ay();
                break;
            case "CustomValueMemberPath":
                if (this.ah != null) {
                    this.ah.deregisterColumn(this.as);
                    this.as = this.ax(this.ct);
                }
                this.a4 = true;
                this.a3 = true;
                this.ae.ay();
                break;
            case "IdMemberPath":
                if (this.ah != null) {
                    this.ah.deregisterColumn(this.at);
                    this.at = this.ax(this.dd);
                }
                this.a4 = true;
                this.a3 = true;
                this.ae.ay();
                break;
            case "LabelMemberPath":
                if (this.ah != null) {
                    this.ah.deregisterColumn(this.au);
                    this.au = this.ax(this.di);
                }
                this.a4 = true;
                this.a3 = true;
                this.ae.ay();
                break;
            case "ParentIdMemberPath":
                if (this.ah != null) {
                    this.ah.deregisterColumn(this.av);
                    this.av = this.ax(this.dq);
                }
                this.a4 = true;
                this.a3 = true;
                this.ae.ay();
                break;
            case "ItemsSource":
                this.ah = ((function () {
                    var $ret = new FastItemsSource();
                    $ret.e = _this.dataSource;
                    return $ret;
                })());
                break;
            case "HeaderLabelLeftMargin":
            case "HeaderLabelTopMargin":
            case "HeaderLabelRightMargin":
            case "HeaderLabelBottomMargin":
            case "HeaderTextColor":
            case "HeaderHoverTextColor":
            case "HeaderHoverBackground":
            case "StrokeThickness":
            case "Outline":
            case "FillBrushes":
            case "IsFillScaleLogarithmic":
            case "FillScaleMinimumValue":
            case "FillScaleMaximumValue":
            case "HeaderBackground":
            case "HeaderHeight":
            case "FillScaleLogarithmBase":
            case "FillScaleMode":
            case "MinimumDisplaySize":
            case "LayoutOrientation":
                this.a4 = true;
                this.ae.ay();
                break;
            case "TextStyle":
                this.ae.av(this.am);
                this.a4 = true;
                this.ae.ay();
                break;
            case "HeaderTextStyle":
                this.ae.as(this.al);
                this.a4 = true;
                this.ae.ay();
                break;
            case "PixelScalingRatio":
                this.bt = c;
                break;
            case "ActualPixelScalingRatio":
                if (this.ae != null) {
                    this.ae.au();
                }
                break;
            case "TransitionProgress":
                if (this.cb >= 1) {
                    this.af.w();
                    var d = this.f;
                    this.f = this.g;
                    this.g = d;
                    this.er();
                    this.eu(this.f);
                    this.ae.ax();
                    this.ae.ay();
                    return;
                }
                this.e.g(this.cb, this.g, this.f);
                this.eu(this.e);
                this.ae.ax();
                break;
            case "Viewport":
                this.a4 = true;
                this.ae.ay();
                break;
            case "FastItemsSource":
                var e = b;
                var f = c;
                if (b != null) {
                    e.event = delegateRemove(e.event, this.cc);
                    this.az = false;
                    e.deregisterColumn(this.ay);
                    e.deregisterColumn(this.at);
                    e.deregisterColumn(this.av);
                    e.deregisterColumn(this.au);
                    e.deregisterColumn(this.as);
                    this.ay = null;
                    this.at = null;
                    this.av = null;
                    this.au = null;
                }
                if (c != null) {
                    f.event = delegateCombine(f.event, this.cc);
                    this.az = true;
                    this.ay = this.aw(this.d3);
                    this.at = this.ax(this.dd);
                    this.av = this.ax(this.dq);
                    this.au = this.ax(this.di);
                    this.as = this.ax(this.ct);
                }
                this.a4 = true;
                this.a3 = true;
                this.ae.ay();
                break;
            case "TransitionDuration":
                this.af.r = this.ch;
                break;
        }
    };
    Object.defineProperty(Treemap.prototype, "fl", {
        get: function () {
            return this.fk;
        },
        set: function (a) {
            var b = this.fk;
            this.fk = a;
            if (!b.equals1(this.fk)) {
                this.en("Viewport", b, this.fk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.d8 = function (a, b) {
        this.cb = this.af.o;
    };
    Object.defineProperty(Treemap.prototype, "d3", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            var b = this.co;
            this.co = a;
            if (b != this.co) {
                this.es("ValueMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dt", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.es("RootTitle", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cq", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.ci;
            this.ci = a;
            if (b != this.cn) {
                this.es("BreadcrumbSequence", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dq", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.en("ParentIdMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "di", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.en("LabelMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ct", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.en("CustomValueMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dd", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.en("IdMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dataSource", {
        get: function () {
            return this.bd;
        },
        set: function (a) {
            var b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.en("ItemsSource", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.en("FillBrushes", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "styleMappings", {
        get: function () {
            return this.v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "d", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.en("FillScaleMode", enumGetBox(TreemapFillScaleMode_$type, b), enumGetBox(TreemapFillScaleMode_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "a5", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.en("IsFillScaleLogarithmic", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cf", {
        get: function () {
            return this.cd;
        },
        set: function (a) {
            var b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.en("FillScaleLogarithmBase", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "bw", {
        get: function () {
            return this.bj;
        },
        set: function (a) {
            var b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.en("FillScaleMinimumValue", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "bv", {
        get: function () {
            return this.bi;
        },
        set: function (a) {
            var b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.en("FillScaleMaximumValue", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "fe", {
        get: function () {
            return this.e1;
        },
        set: function (a) {
            var b = this.e1;
            this.e1 = a;
            if (b != this.e1) {
                this.en("HeaderHoverBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "fd", {
        get: function () {
            return this.e0;
        },
        set: function (a) {
            var b = this.e0;
            this.e0 = a;
            if (b != this.e0) {
                this.en("HeaderBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "fg", {
        get: function () {
            return this.e3;
        },
        set: function (a) {
            var b = this.e3;
            this.e3 = a;
            if (b != this.e3) {
                this.en("HeaderTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "fi", {
        get: function () {
            return this.e5;
        },
        set: function (a) {
            var b = this.e5;
            this.e5 = a;
            if (b != this.e5) {
                this.en("TextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ff", {
        get: function () {
            return this.e2;
        },
        set: function (a) {
            var b = this.e2;
            this.e2 = a;
            if (b != this.e2) {
                this.en("HeaderHoverTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "am", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.en("TextStyle", b, this.aj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "al", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.en("HeaderTextStyle", b, this.ai);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "b5", {
        get: function () {
            return this.bm;
        },
        set: function (a) {
            var b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.en("HeaderLabelLeftMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "b7", {
        get: function () {
            return this.bo;
        },
        set: function (a) {
            var b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.en("HeaderLabelTopMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "b6", {
        get: function () {
            return this.bn;
        },
        set: function (a) {
            var b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.en("HeaderLabelRightMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "b4", {
        get: function () {
            return this.bl;
        },
        set: function (a) {
            var b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.en("HeaderLabelBottomMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "b3", {
        get: function () {
            return this.bk;
        },
        set: function (a) {
            var b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.en("HeaderHeight", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "fh", {
        get: function () {
            return this.e4;
        },
        set: function (a) {
            var b = this.e4;
            this.e4 = a;
            if (b != this.e4) {
                this.en("Outline", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ca", {
        get: function () {
            return this.br;
        },
        set: function (a) {
            var b = this.br;
            this.br = a;
            if (b != this.br) {
                this.en("StrokeThickness", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "z", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            var b = this.y;
            this.y = a;
            if (b != this.y) {
                this.en("LayoutOrientation", enumGetBox(TreemapOrientation_$type, b), enumGetBox(TreemapOrientation_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "j", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.en("LayoutType", enumGetBox(TreemapLayoutType_$type, b), enumGetBox(TreemapLayoutType_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "b8", {
        get: function () {
            return this.bp;
        },
        set: function (a) {
            var b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.en("MinimumDisplaySize", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ch", {
        get: function () {
            return this.ce;
        },
        set: function (a) {
            var b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.en("TransitionDuration", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cb", {
        get: function () {
            return this.bs;
        },
        set: function (a) {
            var b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.en("TransitionProgress", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ah", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.en("FastItemsSource", b, this.ag);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ay", {
        get: function () {
            return this.ar;
        },
        set: function (a) {
            this.ar = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "as", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            this.an = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "av", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            this.aq = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "at", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            this.ao = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "au", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            this.ap = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "b9", {
        get: function () {
            return this.bq;
        },
        set: function (a) {
            var b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.en("PixelScalingRatio", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "bt", {
        get: function () {
            return this.bf;
        },
        set: function (a) {
            var b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.en("ActualPixelScalingRatio", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.aw = function (a) {
        var b = null;
        return this.ah.registerColumn(a, b, false);
    };
    Treemap.prototype.ax = function (a) {
        var b = null;
        return this.ah.registerColumnObject(a, b, false);
    };
    Treemap.prototype.ee = function () {
        this.a4 = true;
        this.ae.ay();
    };
    Object.defineProperty(Treemap.prototype, "a1", {
        get: function () {
            return this.af.f();
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.ab = function () {
        var a = new TreemapTreeData();
        if (this.ay == null || (this.au == null && this.at == null)) {
            return null;
        }
        for (var b = 0; b < this.ah.count; b++) {
            var c = null;
            if (this.as != null && this.as.count > b) {
                c = this.as.item(b);
            }
            var d = this.ay.item(b);
            var e = null;
            var f = "";
            if (this.au != null) {
                f = this.au.item(b) != null ? this.au.item(b).toString() : "";
            }
            if (this.at != null) {
                if (this.at.item(b) == null) {
                    continue;
                }
                e = stringReplace(this.at.item(b).toString(), " ", "_");
            }
            if (e == null) {
                e = stringReplace(f, " ", "_");
                if (stringIsNullOrEmpty(e)) {
                    continue;
                }
            }
            var g = null;
            if (this.av != null) {
                g = this.av.item(b) != null ? stringReplace(this.av.item(b).toString(), " ", "_") : null;
            }
            var h = new TreemapTreeNode();
            h.i = e;
            h.k = g;
            h.h = this.ah.item(b);
            h.f = d;
            h.g = c;
            h.j = f;
            a.e(h);
        }
        a.f();
        return a;
    };
    Treemap.prototype.er = function () {
        if (this.aa == null) {
            this.aa = this.ab();
            if (this.aa == null) {
                return;
            }
        }
        if (this.a7) {
            this.a7 = false;
            for (var a = 0; a < this.aa.d.count; a++) {
                var b = this.aa.b.item(this.aa.d._inner[a]);
                b.c.clear();
                for (var c = 0; c < this.styleMappings.count; c++) {
                    if (this.a2(this.styleMappings._inner[c], b)) {
                        b.c.add(this.styleMappings._inner[c]);
                    }
                }
            }
        }
        if (!this.ae.n()) {
            return;
        }
        var d = new TreemapLayoutSettings();
        d.b = this.aa;
        d.h = this.fl;
        d.c = this.ac;
        d.f = this.b8;
        var e = this.by();
        var f = this.b0();
        var g = this.bz();
        var h = this.bx();
        d.e = this.ae.v("M") + f + h;
        if (!isNaN_(this.b3)) {
            d.e = this.b3;
        }
        d.d = this.ac == null;
        this.h.d(this.f, d);
        var i = 1.7976931348623157E+308;
        var j = -1.7976931348623157E+308;
        if (this.d == 1 || this.d == 3) {
            for (var k = 0; k < this.aa.d.count; k++) {
                var l = 0;
                if (this.d == 1) {
                    l = this.aa.b.item(this.aa.d._inner[k]).e();
                }
                else {
                    l = this.aa.b.item(this.aa.d._inner[k]).f;
                }
                if (!isNaN_(l)) {
                    i = Math.min(l, i);
                    j = Math.max(l, j);
                }
            }
        }
        else {
            for (var m = 0; m < this.f.d.count; m++) {
                var n = 0;
                if (this.d == 0) {
                    n = this.aa.b.item(this.f.d._inner[m]).e();
                }
                else {
                    n = this.aa.b.item(this.f.d._inner[m]).f;
                }
                if (!isNaN_(n)) {
                    i = Math.min(n, i);
                    j = Math.max(n, j);
                }
            }
        }
        for (var o = 0; o < this.f.d.count; o++) {
            var p = this.f.d._inner[o];
            var q = this.aa.b.item(p);
            var r = this.e6(q, i, j);
            var s = this.fb(q);
            var t = this.e7(q);
            var u = this.b2(q);
            var v = this.c1(this.f, q, e, g);
            var w = this.fa(q);
            var x = this.ak(q);
            var y = 0;
            if (this.a6(q)) {
                y = this.ae.w(v);
            }
            else {
                y = this.ae.y(v);
            }
            var z = 0;
            if (this.a6(q)) {
                z = d.e;
            }
            else {
                z = this.ae.x(v);
            }
            this.f.h(q, v, r, s, t, w, u, y, z, e, f, g, h);
            if (q.c.count > 0) {
                for (var aa = 0; aa < q.c.count; aa++) {
                    this.f.e(q, q.c._inner[aa]);
                }
            }
            if (this.nodeStyling != null) {
                var ab = new TreemapNodeStylingEventArgs();
                ab.item = q.h;
                if (q.k != null) {
                    if (this.aa.b.containsKey(q.k)) {
                        var ac = this.aa.b.item(q.k);
                        ab.parentItem = ac.h;
                        ab.parentLabel = ac.j;
                        ab.parentSum = ac.e();
                        ab.parentValue = ac.f;
                    }
                }
                ab.sum = q.e();
                ab.value = q.f;
                ab.customValue = q.g;
                ab.style = new TreemapNodeStyle();
                this.nodeStyling(this, ab);
                this.f.e(q, ab.style);
            }
        }
    };
    Treemap.prototype.a6 = function (a) {
        return a.b != null && a.b.count > 0;
    };
    Treemap.prototype.bx = function () {
        return this.b4;
    };
    Treemap.prototype.bz = function () {
        return this.b6;
    };
    Treemap.prototype.b0 = function () {
        return this.b7;
    };
    Treemap.prototype.by = function () {
        return this.b5;
    };
    Treemap.prototype.d1 = function (a, b, c, d, e) {
        var f = b.length;
        var g = b;
        var h = ("\u2026");
        if (isNaN_(this.bg)) {
            if (this.a6(a)) {
                this.bg = this.ae.w(h);
            }
            else {
                this.bg = this.ae.y(h);
            }
        }
        if (c <= (this.bg + d + e)) {
            return h;
        }
        var i = 0;
        if (this.a6(a)) {
            i = this.ae.w(b);
        }
        else {
            i = this.ae.y(b);
        }
        if (i + d + e <= c) {
            return b;
        }
        var j = c / (i + d + e);
        var k = truncate(Math.ceil(f * j));
        var l = b.substr(0, k) + h;
        var m = 0;
        if (this.a6(a)) {
            m = this.ae.w(l);
        }
        else {
            m = this.ae.y(l);
        }
        if ((m + d + e) > c) {
            f = k;
        }
        else {
            k = k + 1;
            l = b.substr(0, k) + h;
            if (this.a6(a)) {
                m = this.ae.w(l);
            }
            else {
                m = this.ae.y(l);
            }
            if ((m + d + e) > c) {
                f = k;
            }
        }
        while ((i + d + e) > c && f > 0) {
            f--;
            b = b.substr(0, f) + h;
            if (this.a6(a)) {
                i = this.ae.w(b);
            }
            else {
                i = this.ae.y(b);
            }
        }
        return b;
    };
    Treemap.prototype.c1 = function (a, b, c, d) {
        if (b == null) {
            if (this.cq != null && this.dt != null) {
                return this.dt + this.cq;
            }
            return "";
        }
        var e = a.j(b);
        var f = e.width;
        var g = b.j;
        if (this.ac != null && this.ac == b && this.cq != null) {
            var h = null;
            var i = b;
            while (i.k != null) {
                if (this.aa.b.containsKey(b.k)) {
                    h = this.aa.b.item(b.k);
                    if (h.j != null) {
                        g = h.j + this.cq + g;
                    }
                    i = h;
                }
            }
            if (this.dt != null) {
                g = this.dt + this.cq + g;
            }
        }
        var j = 0;
        var k = 0;
        if (a.b(b.i)) {
            var l = a.a(b.i);
            if (b.b.count > 0) {
                j = c;
                k = d;
            }
        }
        return this.d1(b, g, f, j, k);
    };
    Treemap.prototype.b2 = function (a) {
        if (!isNaN_(this.ca)) {
            return this.ca;
        }
        return this.bh;
    };
    Treemap.prototype.e7 = function (a) {
        if (a == this.ad) {
            return this.e8(a);
        }
        if (this.fd != null) {
            return this.fd;
        }
        return this.ae.a1();
    };
    Treemap.prototype.fa = function (a) {
        if (a.b.count > 0) {
            if (a == this.ad) {
                return this.e9(a);
            }
            if (this.fg != null) {
                return this.fg;
            }
            return this.ae.a2();
        }
        else {
            if (this.fi != null) {
                return this.fi;
            }
            return this.ae.a5();
        }
    };
    Treemap.prototype.ak = function (a) {
        if (a.b.count > 0) {
            if (this.al != null) {
                return this.al;
            }
            return this.ae.h();
        }
        else {
            if (this.am != null) {
                return this.am;
            }
            return this.ae.h();
        }
    };
    Treemap.prototype.onDetachedFromUI = function () {
        this.ae.ar();
    };
    Treemap.prototype.onAttachedToUI = function () {
        this.ae.ap();
    };
    Treemap.prototype.e8 = function (a) {
        if (this.fe != null) {
            return this.fe;
        }
        return this.ae.a3();
    };
    Treemap.prototype.e9 = function (a) {
        if (this.ff != null) {
            return this.ff;
        }
        if (this.fg != null) {
            return this.fg;
        }
        return this.ae.a2();
    };
    Treemap.prototype.fb = function (a) {
        if (this.fh != null) {
            return this.fh;
        }
        return this.ae.a4();
    };
    Treemap.prototype.e6 = function (a, b, c) {
        if (this.b == null || this.b.count == 0) {
            return this.fc(a);
        }
        var d = this.b1(a);
        if (isNaN_(d)) {
            return this.fc(a);
        }
        var e = 0;
        if (this.a5 && this.cf > 0) {
            if (d > 0) {
                e = (logBase(d, this.cf) - logBase(b, this.cf)) / (logBase(c, this.cf) - logBase(b, this.cf));
            }
            else {
                return this.fc(a);
            }
        }
        else {
            e = (d - b) / (c - b);
        }
        e = e * (this.b.count - 1);
        return BrushCollectionUtil.b(this.b, e);
    };
    Treemap.prototype.b1 = function (a) {
        switch (this.d) {
            case 0:
            case 1: return a.e();
            case 2:
            case 3: return a.f;
        }
        return a.e();
    };
    Treemap.prototype.fc = function (a) {
        return this.ae.a1();
    };
    Treemap.prototype.eu = function (a) {
        var b = new List$1(TreemapVisual.$, 0);
        var c = this.ae.i();
        var d = 0;
        for (var e = 0; e < a.d.count; e++) {
            var f = a.d._inner[e];
            var g = a.a(f);
            var h = c.item(d);
            if (g.r.isEmpty || (g.r.width == 0 && g.r.height == 0)) {
                h.n = 1;
                continue;
            }
            d++;
            b.add(h);
            h.a = this.ak(g.d);
            h.h = g.n;
            h.k = g.q;
            h.i = g.o;
            h.m = new Thickness(1, g.g, g.i, g.h, g.f);
            h.j = g.p;
            h.g = g.m;
            h.f = g.k;
            h.n = 0;
            h.l = g.r;
            h.b = g.d.b.count == 0;
            h.e = g.j;
            h.d = g.e;
        }
        c.count = d;
        this.ae.af(b);
    };
    Treemap.prototype.bb = function () {
        return !this.fl.isEmpty && this.ae.n();
    };
    Treemap.prototype.ev = function () {
        if (!this.bb()) {
            return;
        }
        if (this.a4) {
            var a = this.g;
            if (this.a1) {
                if (this.af.g) {
                    this.af.t();
                }
                this.g = this.e;
                this.e = a;
            }
            else {
                this.g = this.f;
                this.f = a;
            }
        }
        else if (this.a1) {
            this.e.g(this.cb, this.g, this.f);
            this.eu(this.e);
        }
        if (this.a4) {
            this.er();
        }
        if (this.a4 && this.bc) {
            this.ew();
            this.e.g(this.cb, this.g, this.f);
            this.eu(this.e);
        }
        else {
            if (this.a4) {
                this.eu(this.f);
            }
        }
        this.a4 = false;
        this.ae.ax();
    };
    Treemap.prototype.a2 = function (a, b) {
        var c = null;
        switch (a.ax) {
            case 1:
                c = b.f;
                break;
            case 0:
                c = b.e();
                break;
            case 2:
                c = b.g;
                break;
        }
        if (this.a8(c)) {
            var d = this.bu(c);
            if (a.a5 != null) {
                if (this.a8(a.a5)) {
                    var e = this.bu(a.a5);
                    if (isNaN_(e) && isNaN_(d)) {
                        return true;
                    }
                    if (d == e) {
                        return true;
                    }
                }
            }
            else if (!isNaN_(a.a2) || !isNaN_(a.a1)) {
                var f = a.a2;
                var g = a.a1;
                if (d >= f && d <= g) {
                    return true;
                }
            }
        }
        else if (this.ba(c)) {
            if (a.a5 != null) {
                if (this.ba(a.a5)) {
                    var h = (a.a5);
                    if (Base.equalsStatic(h, c)) {
                        return true;
                    }
                }
            }
        }
        else {
            if (Base.equalsStatic(c, a.a5)) {
                return true;
            }
        }
        return false;
    };
    Treemap.prototype.ba = function (a) {
        return typeof a === 'string';
    };
    Treemap.prototype.bu = function (a) {
        if (typeof a === 'number') {
            return a;
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return a;
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return a;
        }
        return NaN;
    };
    Treemap.prototype.a8 = function (a) {
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        return false;
    };
    Treemap.prototype.l = function (a) {
        var _this = this;
        var e_13, _a;
        var b = this.f;
        if (this.a1) {
            b = this.e;
        }
        var c = new List$1(TreemapNodeFrame.$, 0);
        for (var d = 0; d < b.d.count; d++) {
            var e = b.d._inner[d];
            var f = b.a(e);
            if (a.x >= f.r.left && a.x <= f.r.right && a.y >= f.r.top && a.y <= f.r.bottom) {
                c.add(f);
            }
        }
        c.aa(function (g, h) {
            var i = _this.cg(h);
            var j = _this.cg(g);
            if (i > j) {
                return 1;
            }
            else if (j > i) {
                return -1;
            }
            return 0;
        });
        try {
            for (var _b = tslib_1.__values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var g = _c.value;
                if (g.d.b.count > 0) {
                    return g;
                }
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_13) throw e_13.error; }
        }
        return null;
    };
    Treemap.prototype.cg = function (a) {
        var b = a.d;
        var c = 0;
        while (b.k != null) {
            if (this.aa.b.containsKey(b.k)) {
                c++;
                b = this.aa.b.item(b.k);
            }
        }
        return c;
    };
    Treemap.prototype.m = function (a) {
        var _this = this;
        var e_14, _a;
        var b = this.f;
        if (this.a1) {
            b = this.e;
        }
        var c = new List$1(TreemapNodeFrame.$, 0);
        for (var d = 0; d < b.d.count; d++) {
            var e = b.d._inner[d];
            var f = b.a(e);
            if (a.x >= f.r.left && a.x <= f.r.right && a.y >= f.r.top && a.y <= f.r.bottom) {
                c.add(f);
            }
        }
        c.aa(function (g, h) {
            var i = _this.cg(h);
            var j = _this.cg(g);
            if (i > j) {
                return 1;
            }
            else if (j > i) {
                return -1;
            }
            return 0;
        });
        try {
            for (var _b = tslib_1.__values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var g = _c.value;
                return g;
            }
        }
        catch (e_14_1) { e_14 = { error: e_14_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_14) throw e_14.error; }
        }
        return null;
    };
    Treemap.prototype.ew = function () {
        this.bs = 0;
        this.af.w();
        this.af.v();
    };
    Object.defineProperty(Treemap.prototype, "bc", {
        get: function () {
            return this.ch > 0;
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.provideContainer = function (a) {
        this.ae.aq(a);
        this.af.u(a);
    };
    Treemap.prototype.ec = function () {
        this.ae.al();
    };
    Object.defineProperty(Treemap.prototype, "o", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (b != a) {
                this.ed(b);
                this.eb(a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.eb = function (a) {
        if (a != null) {
            if (this.nodePointerEnter != null) {
                this.nodePointerEnter(this, this.p(a));
            }
        }
    };
    Treemap.prototype.ed = function (a) {
        if (a != null) {
            if (this.nodePointerLeave != null) {
                this.nodePointerLeave(this, this.p(a));
            }
        }
    };
    Treemap.prototype.p = function (a) {
        var b = new TreemapNodePointerEventArgs();
        if (a != null) {
            b.customValue = a.d.g;
            b.item = a.d.h;
            b.position = this.fj;
            b.sum = a.d.e();
            b.value = a.d.f;
            b.label = a.d.j;
            b.isOverHeader = this.a9(this.fj, a);
            if (a.d.k != null && this.aa.b.containsKey(a.d.k)) {
                var c = this.aa.b.item(a.d.k);
                b.parentItem = c.h;
                b.parentSum = c.e();
                b.parentValue = c.f;
                b.parentLabel = c.j;
            }
        }
        b.isRightButton = false;
        return b;
    };
    Treemap.prototype.ei = function (a) {
        this.ez(a);
        if (this.nodePointerPressed != null && this.n != null) {
            var b = this.p(this.n);
            this.nodePointerPressed(this, b);
        }
    };
    Treemap.prototype.em = function (a) {
        this.ez(a);
        var b = false;
        if (this.nodePointerReleased != null && this.n != null) {
            var c = this.p(this.n);
            this.nodePointerReleased(this, c);
            b = c.isHandled;
        }
        if (!b) {
            if (this.n != null) {
                if (this.n.d == this.ac && this.a9(a, this.n)) {
                    this.ac = null;
                    this.a4 = true;
                    this.ae.ay();
                    return;
                }
                this.ac = this.n.d;
                this.a4 = true;
                this.ae.ay();
            }
            else {
                this.ac = null;
                this.a4 = true;
                this.ae.ay();
            }
        }
    };
    Treemap.prototype.a9 = function (a, b) {
        var c = this.f;
        if (this.a1) {
            c = this.e;
        }
        if (b == null) {
            return false;
        }
        var d = b;
        if (a.x >= d.r.left && a.x <= d.r.right && a.y >= d.r.top && a.y <= d.r.bottom) {
            if (a.y - d.r.top <= d.e) {
                return true;
            }
        }
        return false;
    };
    Treemap.prototype.ej = function (a) {
        this.ez(a);
    };
    Treemap.prototype.ek = function (a) {
        this.ez(a);
        this.n = null;
        this.o = null;
        this.a4 = true;
        this.ae.ay();
    };
    Treemap.prototype.ez = function (a) {
        this.fj = { $type: Point_$type, x: a.x, y: a.y };
        this.n = this.l(a);
        this.o = this.m(a);
        this.ey(a);
    };
    Treemap.prototype.el = function (a) {
        this.ez(a);
        if (this.n != null) {
            if (this.nodePointerOver != null) {
                this.nodePointerOver(this, this.p(this.o));
            }
        }
    };
    Treemap.prototype.ey = function (a) {
        if (!this.a1) {
            if (this.a9(a, this.n)) {
                var b = this.ad;
                this.ad = this.n.d;
                if (this.ad != b) {
                    this.a4 = true;
                    this.ae.ay();
                }
            }
            else {
                var c = this.ad;
                this.ad = null;
                if (this.ad != c) {
                    this.a4 = true;
                    this.ae.ay();
                }
            }
        }
    };
    Treemap.prototype.eo = function (a) {
        this.ez(a);
        if (this.nodePointerPressed != null && this.n != null) {
            var b = this.p(this.n);
            b.isRightButton = true;
            this.nodePointerPressed(this, b);
        }
    };
    Treemap.prototype.ep = function (a) {
        this.ez(a);
        var b = false;
        if (this.nodePointerReleased != null && this.n != null) {
            var c = this.p(this.n);
            c.isRightButton = true;
            this.nodePointerReleased(this, c);
            b = c.isHandled;
        }
        if (!b) {
            this.n = null;
            this.ac = null;
            this.a4 = true;
            this.ae.ay();
        }
    };
    Treemap.prototype.eq = function (a) {
        this.a4 = true;
        this.ae.ay();
    };
    Treemap.$t = markType(Treemap, 'Treemap', Base.$, [INotifyPropertyChanged_$type]);
    return Treemap;
}(Base));
export { Treemap };
/**
 * @hidden
 */
var TreemapNodeStyle = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapNodeStyle, _super);
    function TreemapNodeStyle() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = new HashSet$1(String_$type, 0);
        _this.ak = null;
        _this.aj = null;
        _this.am = null;
        _this.p = null;
        _this.ao = null;
        _this.al = null;
        _this.f = DeviceUtils.g(10);
        _this.h = DeviceUtils.g(3);
        _this.g = DeviceUtils.g(10);
        _this.e = DeviceUtils.g(3);
        _this.d = NaN;
        _this.ai = null;
        _this.an = null;
        _this.i = NaN;
        _this.propertyChanged = null;
        return _this;
    }
    TreemapNodeStyle.prototype.ag = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.ah(a, b, c);
    };
    TreemapNodeStyle.prototype.af = function () {
        this.c.clear();
    };
    TreemapNodeStyle.prototype.b = function (a) {
        return this.c.contains(a);
    };
    TreemapNodeStyle.prototype.ah = function (a, b, c) {
        if (!this.c.contains(a)) {
            this.c.add_1(a);
        }
        switch (a) {
        }
        if (this.a != null) {
            this.a.eq(this);
        }
    };
    Object.defineProperty(TreemapNodeStyle.prototype, "ar", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.ag("HeaderHoverBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "aq", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.ag("HeaderBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "at", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.am;
            this.am = a;
            if (b != this.am) {
                this.ag("HeaderTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "aa", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p;
            this.p = a;
            if (b != this.p) {
                this.ag("Label", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "av", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.ag("TextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "as", {
        get: function () {
            return this.al;
        },
        set: function (a) {
            var b = this.al;
            this.al = a;
            if (b != this.al) {
                this.ag("HeaderHoverTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "l", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            var b = this.f;
            this.f = a;
            if (b != this.f) {
                this.ag("HeaderLabelLeftMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "n", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            if (b != this.h) {
                this.ag("HeaderLabelTopMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "m", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            if (b != this.g) {
                this.ag("HeaderLabelRightMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "k", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.e;
            this.e = a;
            if (b != this.e) {
                this.ag("HeaderLabelBottomMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "j", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.ag("HeaderHeight", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "ap", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.ag("Fill", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "au", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.ag("Outline", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "o", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.ag("StrokeThickness", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    TreemapNodeStyle.$t = markType(TreemapNodeStyle, 'TreemapNodeStyle', Base.$, [INotifyPropertyChanged_$type]);
    return TreemapNodeStyle;
}(Base));
export { TreemapNodeStyle };
/**
 * @hidden
 */
var TreemapNodeStyleMapping = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapNodeStyleMapping, _super);
    function TreemapNodeStyleMapping() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a0 = NaN;
        _this.az = NaN;
        _this.ay = NaN;
        _this.a4 = null;
        _this.aw = 1;
        return _this;
    }
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "a3", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.ag("Name", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "a2", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            var b = this.az;
            this.az = a;
            if (b != this.az) {
                this.ag("MinimumValue", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "a1", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.ag("MaximumValue", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "a5", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            var b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.ag("Value", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "ax", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.ag("MappingMode", enumGetBox(TreemapValueMappingMode_$type, b), enumGetBox(TreemapValueMappingMode_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    TreemapNodeStyleMapping.$t = markType(TreemapNodeStyleMapping, 'TreemapNodeStyleMapping', TreemapNodeStyle.$);
    return TreemapNodeStyleMapping;
}(TreemapNodeStyle));
export { TreemapNodeStyleMapping };
/**
 * @hidden
 */
var TreemapNodeStyleMappingCollection = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapNodeStyleMappingCollection, _super);
    function TreemapNodeStyleMappingCollection() {
        var _this = _super.call(this, TreemapNodeStyleMapping.$, 0) || this;
        _this.collectionResetting = null;
        return _this;
    }
    TreemapNodeStyleMappingCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    TreemapNodeStyleMappingCollection.$t = markType(TreemapNodeStyleMappingCollection, 'TreemapNodeStyleMappingCollection', ObservableCollection$1.$.specialize(TreemapNodeStyleMapping.$));
    return TreemapNodeStyleMappingCollection;
}(ObservableCollection$1));
export { TreemapNodeStyleMappingCollection };
/**
 * @hidden
 */
var TreemapNodeStylingEventArgs = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapNodeStylingEventArgs, _super);
    function TreemapNodeStylingEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._value = 0;
        _this._sum = 0;
        _this._customValue = null;
        _this._item = null;
        _this._parentItem = null;
        _this._label = null;
        _this._parentValue = 0;
        _this._parentLabel = null;
        _this._parentSum = 0;
        _this._style = null;
        return _this;
    }
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (a) {
            this._value = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "sum", {
        get: function () {
            return this._sum;
        },
        set: function (a) {
            this._sum = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "customValue", {
        get: function () {
            return this._customValue;
        },
        set: function (a) {
            this._customValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentItem", {
        get: function () {
            return this._parentItem;
        },
        set: function (a) {
            this._parentItem = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "label", {
        get: function () {
            return this._label;
        },
        set: function (a) {
            this._label = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentValue", {
        get: function () {
            return this._parentValue;
        },
        set: function (a) {
            this._parentValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentLabel", {
        get: function () {
            return this._parentLabel;
        },
        set: function (a) {
            this._parentLabel = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentSum", {
        get: function () {
            return this._parentSum;
        },
        set: function (a) {
            this._parentSum = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "style", {
        get: function () {
            return this._style;
        },
        set: function (a) {
            this._style = a;
        },
        enumerable: true,
        configurable: true
    });
    TreemapNodeStylingEventArgs.$t = markType(TreemapNodeStylingEventArgs, 'TreemapNodeStylingEventArgs', EventArgs.$);
    return TreemapNodeStylingEventArgs;
}(EventArgs));
export { TreemapNodeStylingEventArgs };
/**
 * @hidden
 */
var TreemapFrame = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapFrame, _super);
    function TreemapFrame() {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.d = null;
        _this.d = new List$1(String_$type, 0);
        _this.c = new Dictionary$2(String_$type, TreemapNodeFrame.$, 0);
        return _this;
    }
    TreemapFrame.prototype.g = function (a, b, c) {
        this.f();
        for (var d = 0; d < b.d.count; d++) {
            var e = b.d._inner[d];
            if (c.c.containsKey(e)) {
                var f = TreemapNodeFrame.a(a, b.c.item(e), c.c.item(e));
                this.c.addItem(f.l, f);
                this.d.add(f.l);
            }
            else {
                var g = TreemapNodeFrame.c(a, b.c.item(e));
                this.c.addItem(g.l, g);
                this.d.add(g.l);
            }
        }
        for (var h = 0; h < c.d.count; h++) {
            var i = c.d._inner[h];
            if (!b.c.containsKey(i)) {
                var j = TreemapNodeFrame.b(a, c.c.item(i));
                this.c.addItem(j.l, j);
                this.d.add(j.l);
            }
        }
    };
    TreemapFrame.prototype.i = function (a, b) {
        var _this = this;
        var c;
        if (!((function () { var d = _this.c.tryGetValue(a.i, c); c = d.p1; return d.ret; })())) {
            c = new TreemapNodeFrame();
            c.l = a.i;
            c.d = a;
            this.c.item(c.l, c);
            this.d.add(c.l);
        }
        c.r = b;
    };
    TreemapFrame.prototype.j = function (a) {
        var _this = this;
        var b;
        if (!((function () { var c = _this.c.tryGetValue(a.i, b); b = c.p1; return c.ret; })())) {
            return Rect.empty;
        }
        return b.r;
    };
    TreemapFrame.prototype.h = function (a, b, c, d, e, f, g, h, i, j, k, l, m) {
        var _this = this;
        var n;
        if (!((function () { var o = _this.c.tryGetValue(a.i, n); n = o.p1; return o.ret; })())) {
            return;
        }
        n.m = b;
        n.n = c;
        n.q = d;
        n.k = g;
        n.o = e;
        n.j = h;
        n.e = i;
        n.p = f;
        n.g = j;
        n.i = k;
        n.h = l;
        n.f = m;
    };
    TreemapFrame.prototype.f = function () {
        this.d.clear();
        this.c.clear();
    };
    TreemapFrame.prototype.b = function (a) {
        return this.c.containsKey(a);
    };
    TreemapFrame.prototype.a = function (a) {
        return this.c.item(a);
    };
    TreemapFrame.prototype.e = function (a, b) {
        var _this = this;
        var c;
        if (!((function () { var d = _this.c.tryGetValue(a.i, c); c = d.p1; return d.ret; })())) {
            return;
        }
        if (b.b("Label")) {
            c.m = b.aa;
        }
        if (b.b("Fill")) {
            c.n = b.ap;
        }
        if (b.b("Outline")) {
            c.q = b.au;
        }
        if (b.b("StrokeThickness")) {
            c.k = b.o;
        }
        if (b.b("HeaderBackground")) {
            c.o = b.aq;
        }
        if (a.b != null && a.b.count > 0) {
            if (b.b("HeaderTextColor")) {
                c.p = b.at;
            }
        }
        else {
            if (b.b("TextColor")) {
                c.p = b.av;
            }
        }
        if (b.b("HeaderLabelLeftMargin")) {
            c.g = b.l;
        }
        if (b.b("HeaderLabelTopMargin")) {
            c.i = b.n;
        }
        if (b.b("HeaderLabelRightMargin")) {
            c.h = b.m;
        }
        if (b.b("HeaderLabelBottomMargin")) {
            c.f = b.k;
        }
    };
    TreemapFrame.$t = markType(TreemapFrame, 'TreemapFrame');
    return TreemapFrame;
}(Base));
export { TreemapFrame };
/**
 * @hidden
 */
var TreemapNodeFrame = /** @class */ (function (_super) {
    tslib_1.__extends(TreemapNodeFrame, _super);
    function TreemapNodeFrame() {
        var _this = _super.call(this) || this;
        _this.r = null;
        _this.d = null;
        _this.l = null;
        _this.m = null;
        _this.n = null;
        _this.q = null;
        _this.k = 0;
        _this.g = 0;
        _this.i = 0;
        _this.h = 0;
        _this.f = 0;
        _this.p = null;
        _this.o = null;
        _this.j = 0;
        _this.e = 0;
        _this.r = Rect.empty;
        return _this;
    }
    TreemapNodeFrame.a = function (a, b, c) {
        var d = new TreemapNodeFrame();
        d.d = c.d;
        d.l = c.l;
        d.m = c.m;
        var e = c.r;
        if (e.isEmpty) {
            e = new Rect(0, 0, 0, 0, 0);
        }
        var f = b.r;
        if (f.isEmpty) {
            f = new Rect(0, 0, 0, 0, 0);
        }
        d.r = new Rect(0, f.left + (e.left - f.left) * a, f.top + (e.top - f.top) * a, f.width + (e.width - f.width) * a, f.height + (e.height - f.height) * a);
        d.n = BrushUtil.g(b.n, a, c.n, 0);
        d.q = BrushUtil.g(b.q, a, c.q, 0);
        d.o = BrushUtil.g(b.o, a, c.o, 0);
        d.p = BrushUtil.g(b.p, a, c.p, 0);
        d.k = b.k + (c.k - b.k) * a;
        d.g = b.g + (c.g - b.g) * a;
        d.i = b.i + (c.i - b.i) * a;
        d.h = b.h + (c.h - b.h) * a;
        d.f = b.f + (c.f - b.f) * a;
        d.j = b.j + (c.j - b.j) * a;
        d.e = b.e + (c.e - b.e) * a;
        return d;
    };
    TreemapNodeFrame.c = function (a, b) {
        var c = new Rect(0, 0, 0, 0, 0);
        var d = new TreemapNodeFrame();
        d.d = b.d;
        d.m = b.m;
        d.l = b.l;
        var e = b.r;
        if (e.isEmpty) {
            e = new Rect(0, 0, 0, 0, 0);
        }
        d.r = new Rect(0, e.left + (c.left - e.left) * a, e.top + (c.top - e.top) * a, e.width + (c.width - e.width) * a, e.height + (c.height - e.height) * a);
        d.n = BrushUtil.g(b.n, a, null, 0);
        d.q = BrushUtil.g(b.q, a, null, 0);
        d.o = BrushUtil.g(b.o, a, null, 0);
        d.p = BrushUtil.g(b.p, a, null, 0);
        d.k = b.k + (0 - b.k) * a;
        d.g = b.g + (0 - b.g) * a;
        d.i = b.i + (0 - b.i) * a;
        d.h = b.h + (0 - b.h) * a;
        d.f = b.f + (0 - b.f) * a;
        d.j = b.j + (0 - b.j) * a;
        d.e = b.e + (0 - b.e) * a;
        return d;
    };
    TreemapNodeFrame.b = function (a, b) {
        var c = new Rect(0, 0, 0, 0, 0);
        var d = new TreemapNodeFrame();
        d.d = b.d;
        d.m = b.m;
        d.l = b.l;
        var e = b.r;
        if (e.isEmpty) {
            e = new Rect(0, 0, 0, 0, 0);
        }
        d.r = new Rect(0, c.left + (e.left - c.left) * a, c.top + (e.top - c.top) * a, c.width + (e.width - c.width) * a, c.height + (e.height - c.height) * a);
        d.n = BrushUtil.g(null, a, b.n, 0);
        d.q = BrushUtil.g(null, a, b.q, 0);
        d.o = BrushUtil.g(null, a, b.o, 0);
        d.p = BrushUtil.g(null, a, b.p, 0);
        d.k = 0 + (b.k - 0) * a;
        d.g = 0 + (b.g - 0) * a;
        d.i = 0 + (b.i - 0) * a;
        d.h = 0 + (b.h - 0) * a;
        d.f = 0 + (b.f - 0) * a;
        d.j = 0 + (b.j - 0) * a;
        d.e = 0 + (b.e - 0) * a;
        return d;
    };
    TreemapNodeFrame.$t = markType(TreemapNodeFrame, 'TreemapNodeFrame');
    return TreemapNodeFrame;
}(Base));
export { TreemapNodeFrame };
//# sourceMappingURL=TreemapView_combined.js.map